#include <iostream>
#include <vector>
#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "frame.h"
#include "sprite.h"

#define DIM_H	800
#define DIM_V	600

using namespace std;

//dichiariamo un puntatore ad una superficie globale 
SDL_Surface *screen;

//anche bg  globale
SDL_Surface *bg;

int main()
{

	// si inizializza il sistema video  
	if( SDL_Init(SDL_INIT_VIDEO) == -1 )
	{
		// SDL_GetError() ritorna una descrizione dell'errore
		cout << "Errore init SDL: " << SDL_GetError() << endl;
	        return 1;
	}

	// all'uscita del programma esegui SDL_Quit per risistemare le cose
	atexit(SDL_Quit);

	//dichiariamo  un int a 32 bit per i flag da assegnare a screen
	Uint32 flags;

        flags = SDL_HWSURFACE|SDL_DOUBLEBUF;

	// per rendere disegnabile la Superficie bisogna utilizzare SDL_SetVideoMode
	if(!( screen = SDL_SetVideoMode(DIM_H, DIM_V, 0,flags) ))
	{
		  cout << "Problemi con il settaggio dello schermo: " << SDL_GetError() << endl;
		  return 1;
	}

	//carichiamo l'immagine di sfondo
	bg=IMG_Load("data/bg.png");

	//disegnamo lo sfondo su screen
	SDL_BlitSurface(bg, NULL, screen, NULL);
	
	//il vector che conterr le img dello sprite
	vector<string> files;
	
	//carichiamo le stringhe nel vector
	files.push_back("data/tank_01.png");
	files.push_back("data/tank_02.png");
	files.push_back("data/tank_03.png");
	files.push_back("data/tank_04.png");
	files.push_back("data/tank_05.png");
	files.push_back("data/tank_06.png");
	files.push_back("data/tank_07.png");
	files.push_back("data/tank_08.png");
	
	//istanziamo gli sprite
	sprite tank(files);
	sprite tank2(files,0,200,1);
	sprite tank3(files,0,400,3);

	//flag di fine loop principale
	int end=0;
	//limite orizzontale da non superare 
	int x_limit2=DIM_H-tank2.get_w();
	int x_limit3=(DIM_H-tank3.get_w())/3;
	 
	//stato della tastiera
	Uint8* keys;

	while(!end)
	{
		//dichiariamo una struttura SDL_Event
		SDL_Event event;

		// SDL_PollEvent attiva il gestore di eventi
	        while ( SDL_PollEvent(&event) )
		{
			//premendo la x della finestra col mouse si esce
			if ( event.type == SDL_QUIT )  
				end = 1;  

	       		if ( event.type == SDL_KEYDOWN )
			{
				//ma si esce anche premendo Esc
				if ( event.key.keysym.sym == SDLK_ESCAPE ) 
					end = 1; 
				//premendo spazio si passa dalla modalit schermo intero alla modalit 
				//finestra e viceversa
				if ( event.key.keysym.sym == SDLK_SPACE ) 
				{
					flags^=SDL_FULLSCREEN;
					screen = SDL_SetVideoMode(DIM_H, DIM_V, 0,flags);

					//disegnamo lo sfondo su screen
					SDL_BlitSurface(bg, NULL, screen, NULL);
				}
			}
		}
		
		
		//per verificare se un tasto  mantenuto premuto usiamo SDL_GetKeyState che 
		//ritorna un'immagine dei tasti premuti
		keys = SDL_GetKeyState(NULL);
		
		//FRECCIA SU: se il tank non  posizionato a (x,0) andiamo su
		if ( keys[SDLK_UP] ) 
		{	
			if(tank.get_y())
				tank.mov_y(-1);
		}
		//FRECCIA GIU: approssima il bordo inferiore in base al numero di tank e a DIM_V
	        if ( keys[SDLK_DOWN] ) 
		{
			if(tank.get_y()<(DIM_V-tank.get_h()))
				tank.mov_y();
		}
		//FRECCIA SX: se il tank non  posizionato a (0,y) andiamo a sx
	    	if ( keys[SDLK_LEFT] ) 
		{
			if(tank.get_x())
				tank.mov_x(-1);
		}
		//FRECCIA DX: se il tank non  posizionato a (DIM_H-tank->w,y) andiamo a sx
		if ( keys[SDLK_RIGHT] ) 
		{
			if(tank.get_x()<(DIM_H-tank.get_w()))
				tank.mov_x();
		}
			
		//muoviamo il secondo tank, se ci troviamo entro i limiti
		if((x_limit2--)>0)
			tank2.mov_x(1);

		//muoviamo il terzo tank, se ci troviamo entro i limiti
		if((x_limit3--)>0)
			tank3.mov_x(1);
		
		//disegnamo le parti di sfondo interessate
		tank.draw_bg();
		tank2.draw_bg();
		tank3.draw_bg();

		//disegniamo i tank
		tank.draw_sprite();
		tank2.draw_sprite();
		tank3.draw_sprite();

		//aggiorniamo lo schermo
		SDL_Flip(screen);
	}

	return 0;
	
}
